// DRA_U8G_16UHF_POTI_2

#include <string.h>
#include "U8glib.h"

U8GLIB_SSD1306_128X64 u8g(U8G_I2C_OPT_NONE);

int ch, sensorValue;
int ch_old = 20;

// set parameters for DRA818x
int bw = 1;                 // bandwith in KHz ( 0 = 12.5 or 1 = 25 )
float ftx;                  // tx frequency in MHz (400.0000 - 480.0000)
float frx;                  // rx frequency in MHz (400.0000 - 480.0000) 
String ct = "0";            // ctcss frequency ( 0 - 38 ); 0 = "no CTCSS"  
String stn;
int squ = 0;                // squelch level  ( 0 - 8 ); 0 = "open"  

//////////////////////////////////////////////////////////////////
void setup()
{
 Serial.begin(9600);        // open serial at 9600 bps
 delay(100);
}

/////////////////////////////////////////////////////////////////
void loop()
{
sensorValue = analogRead(0);
ch = sensorValue/65;    // 16 channel version (0-15)
if (ch != ch_old)

{                              
     if (ch == 0) { frx = 438.5750; ftx = 430.9750; squ = 1; ct = "0"; stn = "DB0FT  " ; }    
else if (ch == 1) { frx = 438.6250; ftx = 431.0250; squ = 1; ct = "1"; stn = "DF0MOT " ; }    
else if (ch == 2) { frx = 438.7500; ftx = 431.1500; squ = 1; ct = "0"; stn = "DB0HRF " ; }    
else if (ch == 3) { frx = 438.8000; ftx = 431.2000; squ = 1; ct = "0"; stn = "DB0GGW " ; }     
else if (ch == 4) { frx = 438.9500; ftx = 431.3500; squ = 1; ct = "0"; stn = "DB0WAS " ; }    
else if (ch == 5) { frx = 439.3000; ftx = 431.7000; squ = 1; ct = "1"; stn = "DO0SMZ " ; }    
else if (ch == 6) { frx = 439.3250; ftx = 431.7250; squ = 1; ct = "0"; stn = "DB0VA  " ; }    
else if (ch == 7) { frx = 439.8000; ftx = 439.8000; squ = 1; ct = "0"; stn = "Simplex" ; }    
else if (ch == 8) { frx = 430.0250; ftx = 430.0250; squ = 1; ct = "0"; stn = "Simplex" ; }    
else if (ch == 9) { frx = 430.0750; ftx = 430.0750; squ = 1; ct = "0"; stn = "Simplex" ; }    
else if (ch == 10) { frx = 432.4250; ftx = 432.4250; squ = 0; ct = "0"; stn = "DB0MMO" ; }    
else if (ch == 11) { frx = 432.8250; ftx = 432.8250; squ = 1; ct = "0"; stn = "Simplex" ; }    
else if (ch == 12) { frx = 434.9000; ftx = 434.9000; squ = 1; ct = "0"; stn = "Simplex" ; }    
else if (ch == 13) { frx = 434.9250; ftx = 434.9250; squ = 1; ct = "0"; stn = "Simplex" ; }    
else if (ch == 14) { frx = 434.9500; ftx = 434.9500; squ = 1; ct = "0"; stn = "Simplex" ; }    
else if (ch == 15) { frx = 434.9750; ftx = 434.9750; squ = 1; ct = "0"; stn = "Simplex" ; }    

  Serial.print("AT+DMOSETGROUP=");     
  Serial.print(bw);
  Serial.print(",");
  Serial.print(ftx,4); 
  Serial.print(",");
  Serial.print(frx,4);
  Serial.print(",");
  Serial.print(ct);
  Serial.print(",");
  Serial.print(squ);
  Serial.print(",");
  Serial.print(ct);
  Serial.println(",0");

  u8g.firstPage();  
  do {
    draw();
  } while( u8g.nextPage() );
  delay(100);
  }
  ch_old = ch;
}

/////////////////////////////////////////////////////////////////
void draw(void) {
// graphic commands to redraw the complete screen   
  u8g.setFont(u8g_font_unifont);
  u8g.drawStr(2,10,"UHF-TRANSCEIVER");
  u8g.setPrintPos(18,30);
  u8g.print("Ch.");  
  u8g.print(ch+1); 
  u8g.setPrintPos(18,45);
  u8g.print(frx,3);  
  u8g.print(" MHz");
  u8g.setPrintPos(18,60);
  u8g.print(stn);      
}
